#ifndef SIOTClient_h
#define SIOTClient_h
#include <WString.h>
#if defined(ARDUINO_ARCH_ESP32)
    #include <WiFi.h>
    #include <HTTPClient.h>
#elif  defined(ARDUINO_ARCH_ESP8266)
    #include <ESP8266WiFi.h>
    #include <ESP8266HTTPClient.h>
#endif

class SIOTClient{
    private:
        static WiFiClient client;
        static HTTPClient http;        
    private:
        /// @brief  secret key generated by SIOT Center of an IoT device, at http://siot.soict.ai
        String ApiKey;
        /// @brief  IoT device's base URL generated by SIOT Center at http://siot.soict.ai
        /// @example http://siot.soict.ai/api/devices/check-newsiot 
        String DeviceBaseURL;
    public:
        void Checkin(String DeviceId, String ApiKey);
        int Send(String AttributeId, String postdata);
};
#endif